#include "RIPCTest.h"

/**
 * Test for semaphores and events with manual reset
 * Usage: 
 * 1. Start arbiter by "Race N 0" command, 
 * and n-1 paarticipants by "Race N id" commad where 0 < id < N
 * Ouput: none
 */
class Race : public RIPCTest { 
  public:
    void run(RIPCSession* session, int id) {
	RIPCEvent* start = session->createEvent("start", false, true);
	RIPCEvent* finish = session->createEvent("finish", false, true);
	RIPCEvent* temp;
	RIPCSemaphore* semaphore = session->createSemaphore("race", 0);

	if (id == 0) { 
	    int nParticipants = nProcesses - 1;
	    for (int i = 0; i < nIterations; i++) { 
		start->signal();
		for (int j = 0; j < nParticipants; j++) { 
		    semaphore->waitFor();
		}
		start->reset();
		temp = start; start = finish; finish = temp;
	    }
	} else { 
	    for (int i = 0; i < nIterations; i++) { 
		start->waitFor();
		semaphore->signal();
		temp = start; start = finish; finish = temp;
	    }
	}
	start->close();
	finish->close();
	semaphore->close();
    }
};



int main(int argc, char* argv[]) { 
    Race test;
    return test.main(argc ,argv);
}

